<script setup lang="ts">
  import { formatDate } from '~/helpers';
  import { InvitationAnswer, InvitationStatus } from '~/logic/interfaces';

  definePageMeta({
    middleware: ['presentation-pre-action'],
  });

  const nuxtApp = useNuxtApp();

  const route = useRoute();
  const router = useRouter();
  const localePath = useLocalePath();
  const { receiverAnswer, invitationDetail, respondAppointmentInvitation } = useInvitation();
  const { t } = useI18n();

  onBeforeMount(async () => {
    nuxtApp.$setLoading(true);

    await respondAppointmentInvitation(
      route.query.token as string,
      route.query.answer as InvitationAnswer,
    );

    setTimeout(() => {
      nuxtApp.$setLoading(false);
    });
  });

  const headline = computed(() => {
    if (invitationDetail.value?.status === InvitationStatus.STARTED) {
      return t('presentation.appointment.messages.started');
    }

    if (invitationDetail.value?.status === InvitationStatus.ENDED) {
      return t('presentation.appointment.messages.ended');
    }

    switch (receiverAnswer.value) {
      case InvitationAnswer.ACCEPTED:
        return t('presentation.appointment.messages.invitationAccepted');
      case InvitationAnswer.MAYBE:
        return t('presentation.appointment.messages.invitationMaybe');
      case InvitationAnswer.DECLINED:
        return t('presentation.appointment.messages.invitationDeclined');
    }
  });

  const join = () => {
    router.push(
      localePath({
        name: 'presentation-appointmentId',
        params: { appointmentId: route.params.appointmentId as string },
      }),
    );
  };
</script>
<template>
  <RoomLayout :headline="headline">
    <template #icon>
      <span
        class="text-[22rem]/0 mb-8 max-h-[8rem] md:max-h-[16.375rem] md:text-[44rem]"
        :class="
          invitationDetail?.status === InvitationStatus.STARTED
            ? 'i-sw-custom:waiting-room-live?bg'
            : 'i-sw-custom:waiting-room?bg'
        "
      />
    </template>

    <template v-if="invitationDetail" #sublime>
      <span
        v-if="
          !invitationDetail.status &&
          (receiverAnswer === InvitationAnswer.ACCEPTED ||
            receiverAnswer === InvitationAnswer.MAYBE)
        "
        class="text-information-subdued"
      >
        <i18n-t keypath="presentation.appointment.messages.takePlaceOn">
          <template #from>
            <b
              >{{ formatDate(invitationDetail.accessibleFrom.date, 'DD.MM.YYYY HH:mm:ss') }} ({{
                invitationDetail.accessibleFrom.timezone
              }})</b
            >
          </template>

          <template #to>
            <b
              >{{ formatDate(invitationDetail.accessibleTo.date, 'DD.MM.YYYY HH:mm:ss') }} ({{
                invitationDetail.accessibleTo.timezone
              }})</b
            >
          </template>
        </i18n-t>
      </span>

      <span v-else-if="!invitationDetail.status && receiverAnswer === InvitationAnswer.DECLINED">
        {{ $t('presentation.appointment.messages.changeMind') }}
      </span>

      <SwButton
        v-if="invitationDetail.status === InvitationStatus.STARTED"
        size="large"
        class="mt-3 py-3"
        @click="join"
      >
        {{ $t('joinPresentation') }}
      </SwButton>
    </template>
  </RoomLayout>
</template>
